<template>
  <AnonymousPage>
    <template #title>
      Inscription
    </template>
    <template #content>
      <h2>Créez un compte gratuitement pendant 15 jours</h2>
      <div class="col-sm-12 col-md-8">
        <form
          id="registerForm"
          novalidate="novalidate"
        >
          <div class="form-group required">
            <label
              for="companyName"
            >Société&nbsp;:</label>
            <input
              id="companyName"
              v-model="companyName"
              name="companyName"
              type="text"
              class="form-control"
              required="required"
            >
          </div>
          <div class="form-group required">
            <label
              for="firstname"
            >Prénom&nbsp;:</label>
            <input
              id="firstname"
              v-model="firstname"
              name="firstname"
              type="text"
              class="form-control"
              required="required"
            >
          </div>
          <div class="form-group required">
            <label
              for="lastname"
            >Nom&nbsp;:</label>
            <input
              id="lastname"
              v-model="lastname"
              name="lastname"
              type="text"
              class="form-control"
              required="required"
            >
          </div>
          <div class="form-group required">
            <label
              for="email"
            >Email&nbsp;:</label>
            <input
              id="email"
              v-model="email"
              name="email"
              type="email"
              class="form-control"
              required="required"
              minlength="2"
            >
          </div>
          <div class="form-group required">
            <label
              for="phoneNumber"
            >Numéro de téléphone&nbsp;:</label>
            <input
              id="phoneNumber"
              v-model="phoneNumber"
              name="phoneNumber"
              type="number"
              class="form-control"
              required="required"
              minlength="10"
            >
          </div>
          <div class="form-group required">
            <label
              for="password"
            >Mot de passe&nbsp;:</label>
            <p>Une lettre miniscule, une lettre majuscule, un chiffre et un caractère spécial sont requis.</p>
            <p>Votre mot de passe doit faire au moins 12 caractères.</p>
            <div class="input-group">
              <input
                id="password"
                v-model="password"
                name="password"
                :type="passwordVisibility"
                class="form-control"
                autocomplete="off"
                required="required"
              >
              <span class="input-group-btn">
                <button
                  class="btn btn-default"
                  type="button"
                  @mousedown="showPassword"
                  @mouseup="hidePassword"
                ><span class="fa fa-eye" /></button>
              </span>
            </div>
          </div>
          <div class="form-group required">
            <label
              for="passwordConfirm"
            >Confirmation de mot de passe&nbsp;:</label>
            <div class="input-group">
              <input
                id="passwordConfirm"
                v-model="passwordConfirm"
                name="passwordConfirm"
                :type="passwordVisibility"
                class="form-control"
                autocomplete="off"
                required="required"
              >
              <span class="input-group-btn">
                <button
                  class="btn btn-default"
                  type="button"
                  @mousedown="showPassword"
                  @mouseup="hidePassword"
                ><span class="fa fa-eye" /></button>
              </span>
            </div>
          </div>
          <div class="form-group required">
            <label
              for="addressLine1"
            >Adresse&nbsp;:</label>
            <input
              id="addressLine1"
              v-model="addressLine1"
              name="addressLine1"
              type="text"
              class="form-control"
              required="required"
            >
          </div>
          <div class="form-group">
            <label for="addressLine2">Complément d'adresse&nbsp;:</label>
            <input
              id="addressLine2"
              v-model="addressLine2"
              name="addressLine2"
              type="text"
              class="form-control"
            >
          </div>
          <div class="form-group required">
            <label
              for="postalCode"
            >Code postal&nbsp;:</label>
            <input
              id="postalCode"
              v-model="postalCode"
              name="postalCode"
              type="number"
              maxlength="5"
              minlength="5"
              class="form-control"
              required="required"
            >
          </div>
          <div class="form-group required">
            <label
              for="city"
            >Ville&nbsp;:</label>
            <input
              id="city"
              v-model="city"
              name="city"
              type="text"
              class="form-control"
              required="required"
            >
          </div>
          <div class="form-group required">
            <label for="commercialContactCheckbox">
              <input
                id="commercialContactCheckbox"
                v-model="isCommercialContact"
                name="commercialContactCheckbox"
                type="checkbox"
              >
              &nbsp;J'accepte d'être contacté à des fins commerciales pendant la période d'essai de 15 jours du produit
            </label>
          </div>
          <p>
            En vous inscrivant, vous acceptez nos <router-link
              target="_blank"
              :to="{ path: '/conditions-generales-utilisation' }"
            >
              Conditions d'utilisation
            </router-link>, notre <router-link
              target="_blank"
              :to="{ path: '/politique-confidentialite' }"
            >
              Politique de confidentialité
            </router-link> et notre <router-link
              target="_blank"
              :to="{ path: '/utilisation-cookies'}"
            >
              Utilisation des cookies
            </router-link>.
          </p>
          <div class="form-group btn-list">
            <click-button
              :disabled="submitDisabled"
              @click="registerAndRedirect()"
            >
              <template slot="content">
                Inscription
              </template>
            </click-button>
          </div>
        </form>
        <p>
          Déjà un compte ?
          <router-link :to="{ path: '/connexion/'+encodeURI(email)}">
            <a href="#">Me connecter</a>
          </router-link>
        </p>
      </div>
      <div class="col-sm-12 col-md-4">
        <div class="register-alert-info">
          <p><span class="fa fa-info" /> Après avoir créé votre compte, Il vous sera demandé de transmettre vos fichiers DSN.</p><br>
          <p>Grâce aux données contenues dans vos fichiers DSN vous pourrez obtenir en quelques minutes :</p>
          <ul>
            <li>Votre BDES avec plus de 100 indicateurs déjà calculés</li>
            <li>Votre Index d'égalité femmes-hommes</li>
            <li>Vos tableaux de bord RH interactifs.</li>
          </ul>
          <p>Remarque : une option vous permet d'anonymiser les données personnelles contenues dans vos fichiers DSN.</p>
        </div>
        <div class="help">
          <div class="help-phone">
            <span class="icon-phone fa fa-phone" />
            <span class="help-text">Besoin d'aide ? <br> 04 67 67 15 85</span>
          </div>
          <a href="https://www.dsnplus.fr">www.dsnplus.fr</a>
        </div>
      </div>
    </template>
  </AnonymousPage>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import AnonymousPage from '../components/Page/AnonymousPage'
import VanillaToasts from 'vanillatoasts'
import ClickButton from "../components/Button/ClickButton";

export default {
  name: "Register",
  components: {ClickButton, AnonymousPage},
  data() {
    return {
      passwordHidden: true,
      companyName: '',
      firstname: '',
      lastname: '',
      email: '',
      phoneNumber: '',
      password: '',
      passwordConfirm: '',
      addressLine1: '',
      addressLine2: '',
      postalCode: '',
      city: '',
      isCommercialContact: false,
      validator: null
    };
  },
  computed: {
    ...mapGetters([
      'isLoading'
    ]),
    passwordVisibility() {
      return (this.passwordHidden) ? 'password' : 'text'
    },
    submitDisabled: function() {
      return this.isLoading 
      || this.companyName.length === 0 
      || this.firstname.length === 0
      || this.lastname.length === 0
      || this.email.length === 0
      || this.phoneNumber.length === 0 
      || this.password.length === 0
      || this.passwordConfirm.length === 0 
      || this.addressLine1.length === 0
      || this.postalCode.length === 0 
      || this.city.length === 0
      ||this.isCommercialContact === false
    }
  },
  mounted() {
    this.validator = $('#registerForm').submit(function(e) {
      e.preventDefault();
    }).validate({
      rules: {
        email: {
          required: true,
          email: true
        },
        companyName: 'required',
        firstname: 'required',
        lastname: 'required',
        addressLine1: 'required',
        postalCode: {
          required: true,
          maxlength: 5,
          minlength: 5,
          digits: true
        },
        phoneNumber: {
          required: true,
          maxlength: 10,
          minlength: 10,
          digits: true
        },
        city: 'required',
        password: {
          complexPassword: true
        },
        passwordConfirm: {
          required: true,
          minlength: 12,
          equalTo: '#password'
        },
      },
      errorElement: 'em',
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass("help-block");
        if(element[0]['name']=== "password" || element[0]['name']=== "passwordConfirm") {
          error.insertAfter(element[0]['parentElement'])
        }else if (element.prop("type") === "checkbox") {
          error.insertAfter(element.parent("label"));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  methods: {
    ...mapActions([
      'register',
      'loadingStarts',
      'loadingEnds'
    ]),
    registerAndRedirect() {
      this.validator.resetForm();
      if($("#registerForm").valid()) {
        this.loadingStarts()
        let payload = {
          email: this.$data.email,
          companyName: this.$data.companyName,
          firstname: this.$data.firstname,
          lastname: this.$data.lastname,
          password: this.$data.password,
          addressLine1: this.$data.addressLine1,
          addressLine2: this.$data.addressLine2,
          postalCode: this.$data.postalCode,
          city: this.$data.city,
          phoneNumber: this.phoneNumber
        };
        this.register(payload).then(
          () => {
            VanillaToasts.create({
              title: 'Inscription',
              text: 'Opération réussie.<br>Un email de confirmation a été envoyé sur votre boîte mail.',
              type: 'success',
              timeout: 10000, // hide after 5000ms, // optional paremter
            });
            this.$router.push({path: '/compte-activation/' + encodeURI(this.email)})
            this.loadingEnds()
          }
        );
      }
    },
    hidePassword() {
      this.passwordHidden = true
    },
    showPassword() {
      this.passwordHidden = false
    }
  }
}
</script>

<style scoped>
  .register-alert-info {
    display: block;
    margin: 20px auto 0 auto;
    padding: 15px;
    border: 1px solid transparent;
    border-radius: 4px;
    background-image: linear-gradient(to bottom,#d9edf7 0,#b9def0 100%);
    background-repeat: repeat-x;
    text-shadow: 0 1px 0 rgb(255 255 255 / 20%);
    -webkit-box-shadow: inset 0 1px 0 rgb(255 255 255 / 25%), 0 1px 2px rgb(0 0 0 / 5%);
    box-shadow: inset 0 1px 0 rgb(255 255 255 / 25%), 0 1px 2px rgb(0 0 0 / 5%);
    color: #31708f;
    background-color: #d9edf7;
    margin-bottom: 30px;
  }

  h2 {
    margin-top: 0;
    text-align: center;
  }

  .icon-phone {
    padding: 0.2em 0.3em 0.2em 0.3em;
    font-size: 2em;
    background-color: #3b6ab3;
    color:white;
    border-radius: 50%;
  }

  .help {
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: space-evenly;
  }

  .help-phone {
    display: flex;
    flex-direction: row;
    align-items: center;
  }

  .help-text {
    padding-left: 5px;
  }

  .input-group .form-control {
    z-index: 0 !important;
  }
  .input-group-btn:last-child>.btn, .input-group-btn:last-child>.btn-group {
    z-index: 0 !important;
  }
</style>